//  Configure WiFI ESP Click module responses to parse
extern const OK;
extern const NO_CHANGE;
extern const READY;
extern char Get_Response();

extern unsigned char *SSID;
extern unsigned char *password;
extern unsigned char *port;
extern unsigned char ip_address[40];

void WiFI_Configure() {

  //Reseting WiFi module
  TFT_Write_Text("Resetting module...",20, 70);
  do {
    UART3_Write_Text("AT+RST");
    UART3_Write(0x0D);
    UART3_Write(0x0A);
    Delay_ms(2000);
  } while(Get_Response() != READY);
  Delay_ms(1000);

  // Setting WiFi Mode - station mode
  TFT_Write_Text("Setting Station mode...",20, 85);
  do {
    UART3_Write_Text("AT+CWMODE=1");
    UART3_Write(0x0D);
    UART3_Write(0x0A);
    Delay_ms(2000);
  } while(Get_Response() != OK);
  Delay_ms(2000);
  
  //Enable multIPle connection
  TFT_Write_Text("Enabling multiple connection...",20, 100);
  do {
    UART3_Write_Text("AT+CIPMUX=1");
    UART3_Write(0x0D);
    UART3_Write(0x0A);
    Delay_ms(2000);
  } while(Get_Response() != OK);
  Delay_ms(2000);
  
  do {
     // AT+CWJAP="SSID","pasword" <CR><LF>
     TFT_Write_Text("Joining Access point...",20, 115);
     UART3_Write_Text("AT+CWJAP=");
     UART3_Write('"');
     UART3_Write_Text(SSID);
     UART3_Write('"');
     UART3_Write(',');
     UART3_Write('"');
     UART3_Write_Text(password);
     UART3_Write('"');
     UART3_Write(0x0D);
     UART3_Write(0x0A);
     Delay_ms(1000);
  } while(Get_Response() != OK);
  Delay_ms(1000);
  
  do {
     //AT+CWJAP="SSID","pasword" <CR><LF>
     UART3_Write_Text("AT+CWLAP");
     UART3_Write(0x0D);
     UART3_Write(0x0A);
     Delay_ms(1000);
  } while(Get_Response() != OK);
  Delay_ms(1000);

  // Checking WiFi connection status
  do {
    UART3_Write_Text("AT+CIPSTATUS");
    UART3_Write(0x0D);
    UART3_Write(0x0A);
    Delay_ms(1000);
  } while(Get_Response() != OK);
  Delay_ms(1000);
  
  do {
    TFT_Write_Text("Setting module to work as server...",20, 130);
    //AT+CIPSERVER=<mode>,<port><CR><LF>
    UART3_Write_Text("AT+CIPSERVER=1,80");
    UART3_Write(0x0D);
    UART3_Write(0x0A);
    Delay_ms(1000);
  } while(Get_Response() != OK);
  Delay_ms(1000);

  UART3_Write_Text("AT+CIPSTO?");
  UART3_Write(0x0D);
  UART3_Write(0x0A);
  Delay_ms(1000);

  memset(ip_address, 0, 16);


  TFT_Write_Text("Getting STAIP address...",20, 145);
  UART3_Write_Text("AT+CIFSR");
  UART3_Write(0x0D);
  UART3_Write(0x0A);
  Delay_ms(1000);
  while(Get_Response() != OK);
  Delay_ms(1000);
  
  TFT_Write_Text( ip_address, 20, 160);
}